﻿// ECMAScript 5 strict mode
"use strict";

assert2( cr, "cr namespace not created" );
assert2( cr.plugins_, "cr.plugins_ not created" );

/////////////////////////////////////
// Plugin class
cr.plugins_.Lagged_API = function( runtime )
{
  this.runtime = runtime;
};

( function ()
{
  var pluginProto = cr.plugins_.Lagged_API.prototype;

  /////////////////////////////////////
  // Object type class
  pluginProto.Type = function( plugin )
  {
    this.plugin = plugin;
    this.runtime = plugin.runtime;
  };

  var clayRuntime = null;
  var clayInst = null;

  var typeProto = pluginProto.Type.prototype;

  // called on startup for each object type
  typeProto.onCreate = function()
  {
  };

  /////////////////////////////////////
  // Instance class

  pluginProto.Instance = function( type )
  {
    this.type = type;
    this.runtime = type.runtime;
	this.savedAchs=[];
	this._adPlaying=false;
  this._adcnt=0;
  var self=this;
  setInterval(function(){
    self._adcnt++;
  },999);

    // any other properties you need, e.g...
    // this.myValue = 0;
  };

  var instanceProto = pluginProto.Instance.prototype;

  // called whenever an instance is created
  instanceProto.onCreate = function()
  {
    clayRuntime = this.runtime;
    clayInst = this;
	var loadLaggedJs="//lagged.com/api/v2/lagged_dev.js";
    (function(C,l,a,y,_,i,o){C[_]=C[_]||function(){
    (C[_].q=C[_].q||[]).push(arguments)},C[_].l=1*new Date();i=l.createElement(a),
    o=l.getElementsByTagName(a)[0];i.async=1;i.src=y;o.parentNode.insertBefore(i,o)
    })(window,document,'script',loadLaggedJs,'Lagged');
  };

  // only called if a layout object - draw to a canvas 2D context
  instanceProto.draw = function( ctx )
  {
  };

  // only called if a layout object in WebGL mode - draw to the WebGL context
  // 'glw' is not a WebGL context, it's a wrapper - you can find its methods in GLWrap.js in the install
  // directory or just copy what other plugins do.
  instanceProto.drawGL = function ( glw )
  {
  };

  //////////////////////////////////////
  // Conditions

 // pluginProto.cnds = {};
 // var cnds = pluginProto.cnds;

  	//////////////////////////////////////
	// Conditions
	function Cnds() {};

	Cnds.prototype.PauseGame = function(data)
	{
		return true;
	};

	Cnds.prototype.ResumeGame = function(data)
	{
		return true;
	};

	pluginProto.cnds = new Cnds();


  //////////////////////////////////////
  // Actions

  pluginProto.acts = {};
  var acts = pluginProto.acts;

acts.ShowAd = function ( urlkey,thumbnail ) {
if(this._adPlaying||this._adcnt<45){
  console.log('ad played too soon, timer needs to be above 45: ', this._adcnt);
	return true;
}
this._adPlaying=true;
clayRuntime.trigger(cr.plugins_.Lagged_API.prototype.cnds.PauseGame, clayInst);
var self=this;
try{
LaggedAPI['APIAds'].show('interstitial',urlkey,thumbnail,function(response) {
  this._adcnt=-45;
if(response.success) {
console.log('ad done')
}else {
console.log(response.errormsg);
}
self._adPlaying=false;
clayRuntime.trigger(cr.plugins_.Lagged_API.prototype.cnds.ResumeGame, clayInst);
});
}catch(e){
	this._adPlaying=false;
	clayRuntime.trigger(cr.plugins_.Lagged_API.prototype.cnds.ResumeGame, clayInst);
	console.log(e);
};
};
    acts.InitGame = function ( gameid ) {
      LaggedAPI.init(gameid,'lagdevaF3001');
	};

acts.SaveScore = function ( score,board ) {
var boardinfo={};
boardinfo['score']=score;
boardinfo['board']=board;
LaggedAPI['Scores'].save(boardinfo, function(response) {

if(response.success) {
console.log('high score saved')
}else {
console.log(response.errormsg);
}
cr.logexport("LaggedAPI: HS Saved");
});
};

  acts.SaveAchievement = function ( award ) {
if(this.savedAchs.indexOf(award) > -1){

}else{
var ach_numb=[];
ach_numb.push(award);
this.savedAchs.push(award);
LaggedAPI['Achievements'].save(ach_numb, function(response) {
if(response.success) {
console.log('achievement saved')
// note that we could still have a failure errorcode here when the player
// already has an achievement
}else {
console.log(response.errormsg);
}
});
}
};

acts.ShowAwards = function ( ) {
try{
LaggedAPI['Achievements'].show();
}catch(e){
console.log('test mode: open achievement');
}
}

acts.ViewWalkthrough = function ( jwid ) {
console.log("play walkthrough jwid: ", jwid);
try{
window.parent.viewPlaythrough(jwid);
}catch(e){
	try{
    var postmsg='walkthrough|'+jwid;
		window.parent.postMessage(postmsg,'*');
	}catch(e){
		console.log(e);
	}
console.log(e);
}
}

  pluginProto.exps = {};
  var exps = pluginProto.exps;

}() );
